﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Collections;
using System.IO;
namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        XmlDocument doc;
        Osnova osnova;
        Image klic = Image.FromFile("klic.png");

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {


        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() != DialogResult.OK)
            {
                return;
            }
            doc = new XmlDocument();
            try
            {

                doc.Load(openFileDialog1.FileName);
            }
            catch
            {
                MessageBox.Show("neni platne xml");
            }
            osnova = new Osnova(doc);
            Refresh();

        }

        private void button1_Paint(object sender, PaintEventArgs e)
        {


        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawImage(klic, 0, 0);
            int ndoba = 0;
            double cas = 0;
            for (int i = 0; i < 5; i++)
            {
                e.Graphics.DrawLine(Pens.Black, 0, 10 + i * 6, this.ClientSize.Width, 10 + i * 6);

            }
            int posuny = klic.Width;//posun v ose Y


            if (osnova == null)
                return;
            Image cislo = Image.FromFile("C:\\mladez\\velke\\png_pruhledne\\takt_" + osnova.doba[0].ToString() + ".png");
            e.Graphics.DrawImage(cislo, klic.Width - 10, 10);



            foreach (hudelemnt el in osnova.data)
            {
                cas += el.Delka;
                posuny += el.drawnota(posuny, "", e.Graphics);
                if (cas == osnova.doba[ndoba % 2])
                {
                    ndoba++;
                    posuny += 2;
                    e.Graphics.DrawLine(Pens.Black, posuny, 10, posuny, 40);
                    posuny += 2;
                    cas = 0;
                }
            }
        }
    }

    class Osnova
    {
        public int[] doba = new int[2];
        public int ndoba = 0;
        public double casvdobe = 0;
        public ArrayList data = new ArrayList(128);

        public int kolikatadoba()
        {
            return ndoba % 2;
        }

        public Osnova(XmlDocument doc)
        {
            //nak to budu muset rozparsovat
            XmlElement root;
            try
            {
                root = (XmlElement)doc.GetElementsByTagName("skladba")[0];
            }
            catch
            {
                MessageBox.Show("ciklicka chyba");
                return;
            }
            if (root == null)
            {
                MessageBox.Show("ciklicka chyba");
                return;
            }

            //takt
            string takt = root.GetAttribute("takt");
            if (takt == null)
            {
                MessageBox.Show("ciklicka redudantni chyba");
                return;
            }
            //parsace taktu

            string[] taktparse = takt.Split('/');

            if (taktparse.Length != 2)
            {
                MessageBox.Show("ciklicka redudantni chyba");
                return;
            }

            try
            {
                doba[0] = Convert.ToInt32(taktparse[0]);
                doba[1] = Convert.ToInt32(taktparse[0]);
            }
            catch
            {
                MessageBox.Show("ciklicka redudantni chyba v dobe");
                return;
            }

            if (doba[0] < 3 || doba[0] > 5 || doba[1] < 3 || doba[1] > 5)
            {
                MessageBox.Show("ciklicka redudantni chyba v dobe");
                return;
            }

            XmlNodeList noty = root.SelectNodes("*");// je to prasarna ale...

            foreach (XmlNode node in noty)
            {
                //jdem parsova, sice by bylo lepsi pres xmlreader , ale...

                if (node.NodeType == XmlNodeType.Element)
                {
                    XmlElement el = (XmlElement)node;
                    if (el.Name == "nota")
                    {
                        string delka = el.Attributes["delka"].Value;
                        string vyska = el.Attributes["vyska"].Value;



                        try
                        {
                            delka = delka.Replace(".", ",");
                            double idelka = Convert.ToDouble(delka);


                            while (idelka > 0)
                            {
                                double aktdelka = idelka;
                                if (idelka > doba[kolikatadoba()] - casvdobe)
                                {
                                    aktdelka = (doba[kolikatadoba()] - casvdobe);
                                }


                                if (aktdelka > 2)
                                {
                                    if (aktdelka == 2.5 || aktdelka == 3.5)
                                        aktdelka -= 0.5;
                                }
                                else
                                    if (aktdelka > 4)
                                        aktdelka = 4;

                                casvdobe = (casvdobe + aktdelka) % doba[kolikatadoba()];
                                if (ndoba >= doba[kolikatadoba()])
                                    ndoba++;

                                idelka -= aktdelka;
                                bool b = idelka != 0;
                                data.Add(new nota(aktdelka, vyska, b));

                            }
                        }
                        catch
                        {
                            MessageBox.Show("ciklicka redudantni chyba v dobe");
                            return;
                        }
                    }
                    else
                        if (el.Name == "pomlka")
                        {
                            string delka = el.Attributes["delka"].Value;
                            delka = delka.Replace(".", ",");
                            double idelka = Convert.ToDouble(delka);


                            while (idelka > 0)
                            {
                                double aktdelka = idelka;
                                if (idelka > doba[kolikatadoba()] - casvdobe)
                                {
                                    aktdelka = idelka - (doba[kolikatadoba()] - casvdobe);
                                }


                                if (aktdelka > 2)
                                {
                                    if (aktdelka == 2.5 || aktdelka == 3.5)
                                        aktdelka -= 0.5;
                                }
                                else
                                    if (aktdelka > 4)
                                        aktdelka = 4;

                                casvdobe = (casvdobe + aktdelka) % doba[kolikatadoba()];
                                if (ndoba >= doba[kolikatadoba()])
                                    ndoba++;

                                idelka -= aktdelka;
                                data.Add(new pomlka(aktdelka));

                            }
                        }

                }

            }


        }
    }

    class hudelemnt
    {
        public double Delka;
        virtual public int drawnota(int x, string nota, Graphics g)
        {
            return 0;

        }
    }

    class nota : hudelemnt
    {


        int vyska;
        bool presah;
        string[] textvys ={ "C", "Cis", "D", "Dis", "E", "F", "Fis", "G", "Gis", "A", "Ais", "H", "c", "cis", "d", "dis", "e", "f", "fis", "g", "gis", "a", "ais", "h" };
        int[] vyskanoty ={ 0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 14, 15, 16, 17, 18, 20, 21, 22, 23, 24, 25, 26 };

        static Image[] doban;
        static Image[] dobad;

        static Image[] dobank;
        static Image[] dobadk;
        static nota()
        {
            doban = new Image[4];
         //   doban[0] = Image.FromFile(Application.ExecutablePath+"nota_nahoru_0.png");
            doban[0] = Image.FromFile("C:\\mladez\\velke\\png_pruhledne\\nota_nahoru_0.png");
            doban[1] = Image.FromFile("C:\\mladez\\velke\\png_pruhledne\\nota_nahoru_1.png");
            doban[2] = Image.FromFile("C:\\mladez\\velke\\png_pruhledne\\nota_nahoru_2.png");
            doban[3] = Image.FromFile("C:\\mladez\\velke\\png_pruhledne\\nota_4.png");

            dobad = new Image[4];
            dobad[0] = Image.FromFile("C:\\mladez\\velke\\png_pruhledne\\nota_dolu_0.png");
            dobad[1] = Image.FromFile("C:\\mladez\\velke\\png_pruhledne\\nota_dolu_1.png");
            dobad[2] = Image.FromFile("C:\\mladez\\velke\\png_pruhledne\\nota_dolu_2.png");
            dobad[3] = Image.FromFile("C:\\mladez\\velke\\png_pruhledne\\nota_4.png");

          
        }


        public override int drawnota(int y, string nota, Graphics g)
        {
            int delka = 0;
            if (vyska <= 12)
            {
                if (vyska % 2 == 0)
                {
                    bool tecka = false;
                    int x = 65 - (vyska / 2) * 3 - doban[0].Height;
                    if (Delka <= 1)
                        g.DrawImage(doban[(int)(Delka * 2) - 1], y, x);
                    else
                    {
                        if (Delka == 2)
                            g.DrawImage(doban[(int)(Delka)], y, x);
                        if (Delka == 3)
                        {
                            g.DrawImage(doban[(int)(Delka-1)], y, x);
                            tecka = true;
                        }
                        if (Delka == 4)
                         g.DrawImage(doban[(int)(Delka - 1)], y + doban[0].Height - doban[3].Height, x);
                    }
                    if (Delka==1.5||Delka ==3) 
                    
                    {
                        x = 30 + ((vyska / 2) * 3) + 2;
                        g.DrawRectangle(Pens.Black, y + doban[0].Width + 1, x, 2, 2);
                    }


                    delka = doban[0].Width;
                }
            }
            else
            {
                if (vyska % 2 == 0)
                {
                    int x = 59 - (vyska / 2) * 3;
                    if (Delka <= 1)
                        g.DrawImage(doban[(int)(Delka * 2) - 1], y, x);
                    else
                    {
                        if (Delka != 4)
                            g.DrawImage(doban[(int)(Delka)], y, x);
                        else
                            g.DrawImage(doban[(int)(Delka - 1)], y, x);
                    }
                    if ((int)Delka <= Delka) ;
                    else
                    {
                        x = 65 - (vyska / 2) * 3 + 2;
                        g.DrawRectangle(Pens.Black, y + doban[0].Width + 2, x, 2, 2);
                    }


                    delka = doban[0].Width;
                }
            }
            return delka;
        }

        public nota(double delka, string v, bool p)
        {
            Delka = delka;
            presah = p;
            int h = Array.IndexOf(textvys, v);
            if (h < 0)
                throw new Exception("chyba");
            vyska = vyskanoty[h];
        }
    }

    class pomlka : hudelemnt
    {
        static Image[] doban;

        static pomlka()
        {
            doban = new Image[4];
            doban[0] = Image.FromFile("C:\\mladez\\velke\\png_pruhledne\\pomlka_0.png");
            doban[1] = Image.FromFile("C:\\mladez\\velke\\png_pruhledne\\pomlka_1.png");
            doban[2] = Image.FromFile("C:\\mladez\\velke\\png_pruhledne\\pomlka_2.png");
            doban[3] = Image.FromFile("C:\\mladez\\velke\\png_pruhledne\\pomlka_4.png");
        }
        public override int drawnota(int x, string nota, Graphics g)
        {
            if (Delka == 00.5)
            {
                g.DrawImage(doban[0], x, 20);
            }

            if (Delka == 1)
            {
                g.DrawImage(doban[1], x, 20);
            }
            if (Delka == 1.5)
            {
                g.DrawImage(doban[1], x, 20);
                g.DrawRectangle(Pens.Black, x + 15, 25,1,1);
            }
            if (Delka == 2)
            {
                g.DrawImage(doban[3], x, 18);
            }

            if (Delka == 3)
            {
                g.DrawImage(doban[3], x, 18);
                g.DrawRectangle(Pens.Black, x + 15, 20,1,1);
            }

            if (Delka == 4)
            {
                g.DrawImage(doban[3], x, 13);
            }
            return 20;
        }

        public pomlka(double delka)
        {
            Delka = delka;
        }
    }


}